<?php
/**
* @version 1.0.0
* @package RSMail! 1.0.0
* @copyright (C) 2009-2012 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

class rsmailControllerSettings extends JControllerLegacy
{	
	/**
	 * Constructor.
	 *
	 * @param	array	$config	An optional associative array of configuration settings.

	 * @return	rseventsproControllerSettings
	 * @see		JController
	 * @since	1.6
	 */
	public function __construct($config = array()) {
		parent::__construct($config);
		
		$this->registerTask('apply', 'save');
	}
	
	/**
	 * Method to cancel.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function cancel() {
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$this->setRedirect(JRoute::_('index.php?option=com_rsmail', false));
	}
	
	
	/**
	 * Proxy for getModel.
	 *
	 * @param	string	$name	The name of the model.
	 * @param	string	$prefix	The prefix for the PHP class name.
	 *
	 * @return	JModel
	 * @since	1.6
	 */
	public function getModel($name = 'Settings', $prefix = 'rsmailModel', $config = array('ignore_request' => true)) {
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
	
	/**
	 * Method to save configuration.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function save() {
		$jinput	= JFactory::getApplication()->input;
		$data	= $jinput->get('jform', array(), 'array');
		$model	= $this->getModel();
		
		if (isset($data['unsubscribe_lists'])) {
			if (is_array($data['unsubscribe_lists']) && !empty($data['unsubscribe_lists']))
				$data['unsubscribe_lists'] = implode(',',$data['unsubscribe_lists']);
			else $data['unsubscribe_lists'] = '';
		} else $data['unsubscribe_lists'] = '';
		
		if (!$model->save($data)) {
			$this->setMessage($model->getError(), 'error');
		} else {
			$this->setMessage(JText::_('RSM_SETTINGS_SAVED'), 'message');
		}
		
		$task = $this->getTask();
		if ($task == 'save') {
			$this->setRedirect(JRoute::_('index.php?option=com_rsmail', false));
		} elseif ($task == 'apply') {
			$this->setRedirect(JRoute::_('index.php?option=com_rsmail&view=settings', false));
		}
	}
	
	
	/**
	 * Method to test mail connection.
	 *
	 * @return	void
	 * @since	1.6
	 */
	public function test() {
		$model	= $this->getModel();
		
		if (!$model->test()) {
			if ($errors = $model->getError()) {
				foreach ($errors as $error)
					$this->setMessage($error, 'error');
			}
		} else {
			$this->setMessage(JText::_('RSM_CONNECTION_OK'), 'message');
		}
		
		$this->setRedirect('index.php?option=com_rsmail&view=settings');
	}
}