<?php
/**
* @version 1.0.0
* @package RSMail! 1.0.0
* @copyright (C) 2009 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die();
jimport( 'joomla.application.component.model' );

class rsmailModelDebug extends JModelLegacy
{
	protected $_query;
	protected $_data;
	protected $_total=null;
	protected $_pagination=null;
	
	function __construct() {
		parent::__construct();
		
		$this->_buildQuery();
		$app = JFactory::getApplication();

		// Get pagination request variables
		$limit		= $app->getUserStateFromRequest('com_rsmail.debug.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = $app->getUserStateFromRequest('com_rsmail.debug.limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		
		$this->setState('com_rsmail.debug.limit', $limit);
		$this->setState('com_rsmail.debug.limitstart', $limitstart);
	}
	
	protected function _buildQuery() {
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$app	= JFactory::getApplication();
		$id		= $app->input->getInt('id',0);
		$search = $app->getUserStateFromRequest('com_rsmail.filter.search', 'filter_search');
		
		$query->clear()
			->select('*')
			->from($db->qn('#__rsmail_debug'))
			->where($db->qn('IdSession').' = '.$id)
			->order($db->qn('DateSent').' DESC');
		
		if ($search)
			$query->where($db->qn('SubscriberEmail').' LIKE '.$db->q('%'.$search.'%'));
		
		$this->_query = $query;
	}
	
	public function getData() {
		if (empty($this->_data)) {
			$db	= JFactory::getDbo();
			$db->setQuery($this->_query,$this->getState('com_rsmail.debug.limitstart'), $this->getState('com_rsmail.debug.limit'));
			$this->_data = $db->loadObjectList();
		}

		return $this->_data;
	}
	
	public function getTotal() {
		if (empty($this->_total)) {
			$db	= JFactory::getDbo();
			$db->setQuery($this->_query);
			$db->execute();
			$this->_total = $db->getNumRows();
		}
		
		return $this->_total;
	}
	
	public function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('com_rsmail.debug.limitstart'), $this->getState('com_rsmail.debug.limit'));
		}
		return $this->_pagination;
	}
		
	/**
	 * Method to set the side bar.
	 */
	public function getSidebar() {
		if (rsmailHelper::isJ3()) {
			return JHtmlSidebar::render();
		}
		
		return;
	}
	
	/**
	 * Method to set the filter bar.
	 */
	public function getFilterBar() {
		$search = JFactory::getApplication()->getUserStateFromRequest('com_rsmail.filter.search', 'filter_search');
		$options = array();
		$options['search'] = array(
			'label' => JText::_('JSEARCH_FILTER'),
			'value' => $search
		);
		$options['orderDir']  = false;
		$options['limitBox']   = $this->getPagination()->getLimitBox();
		
		$bar = new RSFilterBar($options);
		return $bar;
	}
}