<?php
/**
* @version 1.0.0
* @package RSJoomla! Adapter
* @copyright (C) 2012 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/

defined('_JEXEC') or die('Restricted access');

/**
 * Utility class for Tabs.
 *
 * @package     RSJoomla!
 */
class RSTabs {
	
	protected static $id		= null;
	protected static $titles 	= array();
	protected static $contents = array();
	
	/**
	 * Method to set the tab id
	 *
	 * @return  void
	 */
	public function __construct($id) {
		self::$id	   = preg_replace('#[^A-Z0-9_\. -]#i', '', $id);
	}

	/**
	 * Method to add tab title
	 *
	 * @return  void
	 */
	public function title($label, $id) {
		self::$titles[] = (object) array('label' => $label, 'id' => $id);
	}
	
	/**
	 * Method to add content to the tab
	 *
	 * @return  void
	 */
	public function content($content) {
		self::$contents[] = $content;
	}
	
	/**
	 * Render tabs
	 *
	 * @return  string  HTML for tabs
	 */
	public function render() {
		$html   = array();
		
		$html[] = JHtml::_('tabs.start', self::$id, array('useCookie' => 1));
		foreach (self::$titles as $i => $title) {
			$html[] = JHtml::_('tabs.panel', JText::_($title->label), $title->id);
			$html[] = self::$contents[$i];
		}
		$html[] = JHtml::_('tabs.end');
		
		return implode("\n",$html);
	}
}