<?php
/**
 * @version     5.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence App Center
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @Copyright Copyright (C) 2008 - 2012 ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined('_JEXEC') or die(';)');

class OSEAPPCENTERControllerDashboard extends OSEAPPCENTERController
{

	function __construct()
	{
		parent::__construct();
	}
	function returnMessages($status, $messages)
	{
		$result = array();
		if ($status == true) {
			$result['success'] = true;
			$result['status'] = 'Done';
			$result['result'] = $messages;
		}
		else {
			$result['success'] = false;
			$result['status'] = 'Error';
			$result['result'] = $messages;
		}
		$result = OSESoftHelper::encode($result);
		echo $result; exit;
	}
	function getApps()
	{
		$model = $this->getModel('dashboard');
		$appType = JRequest::getCmd('type');
		$items = $model->getApps($appType);
		$return['total'] = count($items);
		$return['results'] = $items;
		$return['id'] = 0;
		return $return;
	}
	function getConfiguration()
	{
		$model = $this->getModel('dashboard');
		$items = $model->getConfiguration();
		$result = OSESoftHelper::encode($items);
		echo $result; exit; 
	}
	function saveConfiguration()
	{
		$model = $this->getModel('dashboard');
		$result = $model->saveConfiguration();
		if ($result==true)
		{
			$this->returnMessages(true, JText::_('Configuration saved successfully'));
		}
		else
		{
			$this->returnMessages(false, JText::_('Failed saving configuration'));			
		}		
	}
	function adminlogin()
	{
		$model = $this->getModel('dashboard');
		$result = $model->adminlogin();
		if ($result==true)
		{
			$this->returnMessages(true, JText::_('Secret word is correct'));
		}
		else
		{
			$this->returnMessages(false, JText::_('Secret word is incorrect'));			
		}	
	}
}
?>