<?php
/**
 * @version       1.0 +
 * @package       Open Source Excellence App Store Software
 * @author        Open Source Excellence (R) {@link  http://www.opensource-excellence.com}
 * @author        Created on 01-Oct-2011
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 *  @Copyright Copyright (C) 2008-2012 Open Source Excellence (R)
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined('_JEXEC') or die(';)');
jimport('joomla.application.component.view');

class OSEAPPCENTERView extends JView
{
	var $com_name = '';

	function display($tpl = null)
	{
		$this->com_name = OSESoftHelper::getExtensionName();
		$document = JFactory::getDocument();
		$document->addScript(JURI::root().'media/system/js/core.js');
		self::initCss();
		self::initMeta();
		parent::display($tpl);
	}

	public function initCss()
	{
		$this->com_name = OSESoftHelper::getExtensionName();
		JHTML::stylesheet('components/com_ose_cpu/extjs/resources/css/ose-all.css');
		JHTML::stylesheet('administrator/components/com_ose_cpu/assets/css/old.css');
		JHTML::stylesheet('administrator/components/com_ose_cpu/assets/css/osesoft.css');
		JHTML::stylesheet('administrator/components/' . $this->com_name . '/assets/css/style.css');
	}

	public function initScript($type = 'extjs')
	{
		$this->com_name = OSESoftHelper::getExtensionName();
		switch ($type) {
			case ('jquery'):
				JHTML::script('components/com_ose_cpu/jquery/jquery.min.js');
				JHTML::script('components/com_ose_cpu/extjs/adapter/jquery/ext-jquery-adapter.js');
				JHTML::script('components/com_ose_cpu/extjs/ext-all.js');
				break;
			case ('app'):
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/jquery.min.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/jquery-ui.min.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/functions.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/plugins.js');
				// Plugins ;
				//JHTML::script('administrator/components/'.$this->com_name.'/assets/js/editor.js');
				//JHTML::script('administrator/components/'.$this->com_name.'/assets/js/calendar.js');
				//JHTML::script('administrator/components/'.$this->com_name.'/assets/js/flot.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/elfinder.js');
				//JHTML::script('administrator/components/'.$this->com_name.'/assets/js/datatables.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Alert.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Autocomplete.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Breadcrumb.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Calendar.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Chart.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Color.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Date.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Editor.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_File.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Dialog.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Fileexplorer.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Form.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Gallery.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Multiselect.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Number.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Password.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Slider.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Store.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Time.js');
				//JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Valid.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/wl_Widget.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/config.js');
				JHTML::script('administrator/components/' . $this->com_name . '/assets/js/script.js');
				break;
			case ('extjs'):
			default:
				JHTML::script('components/com_ose_cpu/extjs/adapter/ext/ext-base.js');
				JHTML::script('components/com_ose_cpu/extjs/ext-all.js');
				break;
		}
	}

	public function initMeta()
	{
		$document = JFactory::getDocument();
		$document->setMetadata('Description', 'OSE App Center™');
		$document->setMetadata('Generator', 'OSE App Center™ - the central application platform creasted by Open Source Excellence');
		$document->setMetadata('Author', 'Open Source Excellence');
		// Apple iOS and Android stuff //
		$document->setMetadata('apple-mobile-web-app-capable', 'no');
		$document->setMetadata('apple-mobile-web-app-status-bar-style', 'black');
		// Apple iOS and Android stuff - don't remove! //
		$document->setMetadata('viewport', 'width=device-width,initial-scale=1,user-scalable=no,maximum-scale=1');
	}

	public function initACCss()
	{
		$this->com_name = OSESoftHelper::getExtensionName();
		//JHTML::stylesheet('administrator/components/' . $this->com_name . '/assets/css/googlefont.css');
		JHTML::stylesheet('administrator/components/' . $this->com_name . '/assets/css/style.css');
		JHTML::stylesheet('administrator/components/' . $this->com_name . '/assets/css/light/theme.css');
	}
}
?>