<?php
/**
 * @version     6.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence CPU
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @author        Updated on 30-Mar-2013 
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
defined('_OSEEXEC') or die("Direct Access Not Allowed");
?>
<script type="text/javascript" >
Ext.ns('oseATH','oseATHDashboard');

function resetDatabaseAjax() {
	Mask= new Ext.LoadMask(Ext.getBody(), {msg:'Please wait...'});
	Mask.show();
	Ext.Ajax.request({
		url : url ,
		params : {
			option : option,
			task: 'resetDatabase',
			controller:controller
		},
		method: 'POST',
		success: function (response, options)
		{
			Mask.hide();
			var message = Ext.decode(response.responseText);
			Ext.Msg.show({title: message.status, msg: message.result});
		}
	});
}

function resetDatabase () {
	Ext.Msg.confirm('Confirmation','Please confirm that you would like to reinstall the database', function(btn, text){
		if (btn == 'yes'){
			resetDatabaseAjax();
	    }
     });
}

oseATHDashboard.fields = new Array('date', 'type0', 'type1', 'type2', 'type3', 'type4', 'type5', 'type6', 'type7', 'type8', 'type9', 'type10', 'type11', 'type12', 'type13', 'type14');
oseATHDashboard.store = oseGetStore('attacksum', oseATHDashboard.fields, url, option, controller, 'getAttackSummary');
Ext.onReady(function(){
	var dashboardchart = Ext.create('Ext.chart.Chart', {
	   store: oseATHDashboard.store,
	   width: 1280,
	   height: 600,
	   style: 'background:#fff',
       animate: false,
       shadow: true,
       theme: 'Category1',
       legend: {position: 'right' },
       axes: [{
                type: 'Numeric',
                position: 'left',
                fields: ['type0', 'type1', 'type2', 'type3', 'type4', 'type5', 'type6', 'type7', 'type8', 'type9', 'type10', 'type11', 'type12', 'type13', 'type14'],
                title: 'Number of Hits',
                majorTickSteps: 9,
                minorTickSteps: 1,
                minimum: 0,
                maximum: 100
            }, {
                type: 'Category',
                position: 'bottom',
                fields: ['date'],
                title: 'Date'
            }],
       series: [
	            oseGetIPChartElement('date', 'type0', 'Manually added', 'cross', ' ips added on '),
	            oseGetIPChartElement('date', 'type1', 'Layer 1 Intrusion', 'cross', ' attacks on '),
	            oseGetIPChartElement('date', 'type2', 'Cross-site scripting', 'cross', ' attacks on '),
	            oseGetIPChartElement('date', 'type3', 'Cross-site request forgery', 'cross', ' attacks on '),
	            oseGetIPChartElement('date', 'type4', 'SQL Injection', 'cross', ' attacks on '),
	            oseGetIPChartElement('date', 'type5', 'Remote File Inclusion', 'cross', ' attacks on '),
	            oseGetIPChartElement('date', 'type6', 'Local File Inclusion', 'cross', ' attacks on '),
	            oseGetIPChartElement('date', 'type7', 'Layer 2 Intrusion', 'circle', ' attacks on '),
	            oseGetIPChartElement('date', 'type8', 'Directory Traversal', 'circle', ' attacks on '),
	            oseGetIPChartElement('date', 'type9', 'Denial-of-Service Attack', 'circle', ' attacks on '),
	            oseGetIPChartElement('date', 'type10', 'Local File Modification Attampt', 'circle', ' attacks on '),
	            oseGetIPChartElement('date', 'type11', 'Spamming', 'square', ' attacks on '),
	            oseGetIPChartElement('date', 'type12', 'Format String Attack', 'square', ' attacks on '),
	            oseGetIPChartElement('date', 'type13', 'Inconsistent File Type', 'square', ' attacks on '),
	            oseGetIPChartElement('date', 'type14', 'Virus File', 'square', ' attacks on ')
            ]
	});
	Ext.create('Ext.panel.Panel', {
	        renderTo: 'dashboardchart',
	        items:[
	        	dashboardchart
	        ]
	});
})
</script>