<?php
/**
 * @version     2.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Centrora Security Firewall
 * @subpackage    Open Source Excellence WordPress Firewall
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 01-Jun-2013
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  @Copyright Copyright (C) 2008 - 2012- ... Open Source Excellence
 */
if (!defined('OSE_FRAMEWORK') && !defined('OSEFWDIR') && !defined('_JEXEC'))
{
	die('Direct Access Not Allowed');
}
require_once('BaseModel.php');
class DownloadModel extends BaseModel {
	public function __construct() {
		oseFirewall::loadLanguage();
	}
	public function download($type, $downloadKey) {
		oseFirewall::callLibClass('downloader', 'oseDownloader');
		$downloader = new oseDownloader($type, $downloadKey);
		return $downloader ->download ();
	}
	public function updateVersion ($type, $version) {
		oseFirewall::callLibClass('downloader', 'oseDownloader');
		$downloader = new oseDownloader($type, null);
		return $downloader ->updateVersion ($type, $version);
	}
	public function update($type, $downloadKey) {
		oseFirewall::callLibClass('downloader', 'oseDownloader');
		$downloader = new oseDownloader($type, $downloadKey);
		return $downloader ->update ();
	}
	public function getEmailConfig () {
		oseFirewall::callLibClass('downloader', 'oseDownloader');
		$downloader = new oseDownloader('ath', null);
		return $downloader ->getEmailConfig ();
	}
	public function vsscan ($step, $type) {
		oseFirewall::callLibClass('vsscanner', 'vsscanner');
		$virusScanner = new virusScanner();
		$virusScanner->scheduleScanning($step, $type); 
	}
	public function getDomainCount () {
		oseFirewall::callLibClass('panel', 'panel');
		$panel = new panel();
		return $panel ->getDomainCount ();
	}
    public function runScheduledBackup ($cloudbackuptype, $upload , $fileNum ) {
        oseFirewall::callLibClass('backup', 'oseBackup');
        $oseBackupManager = new oseBackupManager();
        $oseBackupManager ->ScheduledBackup ($cloudbackuptype, $upload , $fileNum );
    }

	public function clearBlacklistIP ($ClearIPKey)
	{
		oseFirewall::callLibClass('ipmanager', 'ipmanager');
		$ipmanager = new oseFirewallIpManager(oseFirewall::getDBO());
		return $ipmanager->clearBlacklistIP ($ClearIPKey);
	}
    public function getStats()
    {
        oseFirewall::callLibClass('cpcentrora', 'cpcentrora');
        $cpcentrora = new cpcentrora();
        return $cpcentrora->getAllStats ();
    }
}