<?php
/**
 * @version   $Id: gantry.config.php 16346 2013-12-02 01:50:13Z arifin $
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2013 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
defined('JPATH_BASE') or die();

$gantry_presets = array(
    'presets' => array(
        'preset1' => array(
            'name'                  => 'Preset 1',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#CBCBCB',
            'header-opacity'        => '20%',
            'header-background'     => '#0C0C0C',
            'header-type'           => 'preset1',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#686868',
            'utility-background'    => '#181818',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#585858',
            'feature-opacity'       => '35%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset1',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#46AB7D',
            'main-accent2'          => '#58DBA0',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#278F63',   
            'extension-type'        => 'paradigm',          

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#686868',
            'footer-background'     => '#0C0C0C'
        ),
        'preset2' => array(
            'name'                  => 'Preset 2',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#F0F0F0',
            'header-opacity'        => '0%',
            'header-background'     => '#282828',
            'header-type'           => 'preset2',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#EEEEEE',
            'utility-background'    => '#0D8BBA',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#686868',
            'feature-opacity'       => '10%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset2',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#2BA3D4',
            'main-accent2'          => '#3DC0F1',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#0D8BBA',      
            'extension-type'        => 'paradigm',       

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#686868',
            'footer-background'     => '#0C0C0C'
        ),
        'preset3' => array(
            'name'                  => 'Preset 3',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#D9D9D9',
            'header-opacity'        => '20%',
            'header-background'     => '#282828',
            'header-type'           => 'preset3',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#D2EBFA',
            'utility-background'    => '#3F657A',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#585858',
            'feature-opacity'       => '35%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset3',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#D54C71',
            'main-accent2'          => '#E8688A',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#A53E58',   
            'extension-type'        => 'paradigm',          

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#A0A0A0',
            'footer-background'     => '#223540'
        ),
        'preset4' => array(
            'name'                  => 'Preset 4',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#CBCBCB',
            'header-opacity'        => '20%',
            'header-background'     => '#282828',
            'header-type'           => 'preset4',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#B0A8B3',
            'utility-background'    => '#423D43',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#585858',
            'feature-opacity'       => '30%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset4',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#A174C3',
            'main-accent2'          => '#B894D6',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#7C5894',   
            'extension-type'        => 'paradigm',          

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#B0A8B3',
            'footer-background'     => '#423D43'
        ),
        'preset5' => array(
            'name'                  => 'Preset 5',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#CBCBCB',
            'header-opacity'        => '20%',
            'header-background'     => '#282828',
            'header-type'           => 'preset5',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#ABA4A2',
            'utility-background'    => '#665C5A',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#585858',
            'feature-opacity'       => '30%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset5',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#E04D2D',
            'main-accent2'          => '#F56342',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#A63920',   
            'extension-type'        => 'paradigm',          

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#ABA4A2',
            'footer-background'     => '#665C5B'
        ),
        'preset6' => array(
            'name'                  => 'Preset 6',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#CBCBCB',
            'header-opacity'        => '60%',
            'header-background'     => '#1F6E4D',
            'header-type'           => 'preset6',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#9DCCB8',
            'utility-background'    => '#195C40',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#383838',
            'feature-opacity'       => '35%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset6',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#4BB888',
            'main-accent2'          => '#54D199',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#2C9C6E',   
            'extension-type'        => 'paradigm',          

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#686868',
            'footer-background'     => '#0C0C0C'
        ),
        'preset7' => array(
            'name'                  => 'Preset 7',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#F0F0F0',
            'header-opacity'        => '50%',
            'header-background'     => '#0F6787',
            'header-type'           => 'preset7',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#EEEEEE',
            'utility-background'    => '#0D8BBA',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#383838',
            'feature-opacity'       => '35%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset7',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#2BA3D4',
            'main-accent2'          => '#3DC0F1',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#0D8BBA',      
            'extension-type'        => 'paradigm',       

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#686868',
            'footer-background'     => '#0C0C0C'
        ),
        'preset8' => array(
            'name'                  => 'Preset 8',

            'header-overlay'        => 'dark',
            'header-text-color'     => '#E0E0E0',
            'header-opacity'        => '50%',
            'header-background'     => '#96341E',
            'header-type'           => 'preset8',

            'scrolling-header'      => 'enable',
            'scrolling-overlay'     => 'light',
            'scrolling-text-color'  => '#7D7D7D',
            'scrolling-background'  => '#F5F5F5',            

            'utility-overlay'       => 'dark',
            'utility-text-color'    => '#FABDAF',
            'utility-background'    => '#96341E',
            
            'feature-overlay'       => 'light',
            'feature-text-color'    => '#383838',
            'feature-opacity'       => '35%',
            'feature-background'    => '#FFFFFF',
            'feature-type'          => 'preset8',

            'maintop-overlay'       => 'light',
            'maintop-text-color'    => '#868686',
            'maintop-background'    => '#FAFAFA',

            'main-body-overlay'     => 'light',
            'main-accent'           => '#E04D2D',
            'main-accent2'          => '#F56342',

            'mainbottom-overlay'    => 'light',
            'mainbottom-text-color' => '#868686',
            'mainbottom-background' => '#FFFFFF',

            'extension-overlay'     => 'dark',
            'extension-text-color'  => '#EFEFEF',
            'extension-background'  => '#A63920',   
            'extension-type'        => 'paradigm',          

            'footer-overlay'        => 'dark',
            'footer-text-color'     => '#ABA4A2',
            'footer-background'     => '#665C5B'
        )
    )
);
        