<?php
/**
 * @version     6.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence CPU
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @author        Updated on 30-Mar-2013 
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
defined('_OSEEXEC') or die('Restricted access');
class ose_antihackerControllerVariables extends ose_antihackerController {
	public function __construct() {
		parent :: __construct();
	}
	public function getVariables()
	{
		$model= $this->getModel('Variables');
		$results = $model ->getVariables();
		oseCPU::returnJSON($results);  
	}
	public function changeVarStatus()
	{
		$oseCPU = new oseCPU(); 
		$id= $oseCPU->getInt('id');
		$status= $oseCPU->getInt('status');
		if (empty($id) || (!in_array($status, array(1,2,3))))
		{
			return; 
		}
		$model= $this->getModel('Variables');
		$result = $model -> changeVarStatus(array($id), $status);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable rule has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable rule was changed unsuccessfully."), false);
		}
	}
	public function addvariables()
	{
		$oseCPU = new oseCPU(); 
		$requesttype= $oseCPU->getVar('requesttype',null);
		$variable= $oseCPU->getVar('variablefield',null);
		$status= $oseCPU->getInt('statusfield',null);
		if (empty($variable) || (!in_array($status, array(1,2,3))))
		{
			return; 
		}
		$variable = $requesttype.'.'.$variable;
		$model= $this->getModel('Variables');
		$result = $model -> addvariables($variable, $status);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable rule has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable rule was changed unsuccessfully."), false);
		}
	}
	public function deletevariable()
	{
		$oseCPU = new oseCPU(); 
		$ids= $oseCPU->getVar('ids',null);
		$ids = oseJSON::decode($ids);
		if (empty($ids))
		{
			return; 
		}
		$model= $this->getModel('Variables');
		$result = $model -> deletevariable($ids);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable was changed unsuccessfully."), false);
		}
	}
	public function loadJoomlarules()
	{
		$model= $this->getModel('Variables');
		$result = $model -> loadJoomlarules();
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable has been restored successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable was restored unsuccessfully."), false);
		}
	}
	public function loadWordpressrules()
	{
		$model= $this->getModel('Variables');
		$result = $model -> loadWordpressrules();
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable has been restored successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable was restored unsuccessfully."), false);
		}
	}
	public function loadJSocialrules()
	{
		$model= $this->getModel('Variables');
		$result = $model -> loadJSocialrules();
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable has been restored successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable was restored unsuccessfully."), false);
		}
	}
	public function clearvariables()
	{
		$model= $this->getModel('Variables');
		$result = $model -> clearvariables();
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Variable has been restored successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Variable was restored unsuccessfully."), false);
		}
	}
	
	public function viewAttack () 
	{
		$model = $this->getModel('variables');
		$oseCPU = new oseCPU(); 
		$aclid= $oseCPU->getInt('id');
		$return = array();
		$return['id'] = 1; 
		$return['results'] = $model->getAttackDetail($aclid);
		oseCPU::returnJSON($return); 
	}	
}	