<?php
/**
  * @version     3.0 +
  * @package       Open Source Excellence Security Suite
  * @subpackage    Open Source Excellence CPU
  * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
  * @author        Created on 30-Sep-2010
  * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
  *
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *  @Copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
*/
defined('_JEXEC') or die(';)');
jimport('joomla.application.component.controller');
/**
 * ssrrn_acl Controller
 *
 * @package    ssrrn_acl
 * @subpackage Controllers
 */
class ose_antivirusControllerQuarantine extends ose_antivirusController {
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	private $virScan = null ; 
	function __construct() {
		parent :: __construct();
		$this->virScan= new oseVirusScanner ();
	} // function
	function getQuarantined() {
		$records= $this->virScan->getQuarantineList();
		$results= array();
		$dir_above= substr(JPATH_ROOT, 0, strrpos(JPATH_ROOT, DS));
		if(!@ is_readable($dir_above) || !is_dir($dir_above)) {
			$rootPath= JPATH_ROOT;
		} else {
			$rootPath= $dir_above;
		}
		unset($dir_above);
		$i= 0;
		foreach($records as $record) {
			$results[$i]->id= $record->id;
			$results[$i]->filepath= $record->filepath;
			$results[$i]->quar_name= $record->quar_name;
			$file= str_replace($rootPath, '', JPATH_ADMINISTRATOR.DS.'components/com_ose_antivirus/quaran'.DS.$results[$i]->quar_name);
			$file= str_replace("\\", "\\\\", $file);
			$results[$i]->view= "<a href='index.php?option=com_osefileman&action=edit&dir=&order=name&srt=yes&item=".$file."' class='modal' rel=\"{handler: 'iframe', size: {x: 980, y: 500}}\"><img src='components/com_ose_antivirus/assets/images/page_white_magnify.png' /></a>";
			$i++;
		}
		$return['results']= $results;
		$return['total']= $this->virScan->getStat()->getQuarantineTotal();
		echo $this->oseJSON->encode($return);
		exit;
	}
	function vsquarantineremove() {
		$filesids= JRequest :: getVar('filesids');
		$this->virScan->fileQuarantineRemove($filesids);
	}
	function vsquarantineremoveall() {
		$this->virScan->fileQuarantineRemoveAll();
	}
	function vsquarantinerestore() {
		$filesids= JRequest :: getVar('filesids');
		$this->virScan->fileRestore($filesids);
	}
	function vsquarantinerestoreall() {
		$filesids= JRequest :: getVar('filesids');
		$this->virScan->fileRestore($filesids, true);
	}
}