<?php
/**
 * @version     5.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence App Center
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @Copyright Copyright (C) 2008 - 2012 ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined('_JEXEC') or die(';)');
jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.path');

class OSEAPPCENTERController extends JController
{
	protected $controller = null, $_c = null, $com_name = 'com_ose_appcenter';

	function __construct()
	{
		$this->checkisadmin();
		parent::__construct();
	}
	
	function checkisadmin()
	{
		$view = JRequest::getVar('view');
		$task = JRequest::getVar('task');
		$db = JFactory::getDBO();
		$secretword = JRequest::getVar('secretword');
		$query = " SELECT `value` FROM `#__ose_app_conf` WHERE `key` = 'secretword'";
		$db->setQuery($query);
		$result = $db -> loadResult();
		
		$session = JFactory::getSession();
		$oseisadmin = $session ->get('oseisadmin');
		if ($task!='adminlogin' && $view !='adminlogin' && empty($oseisadmin) && !empty($result))
		{
			$mainframe = JFactory::getApplication(); 
			$mainframe ->redirect('index.php?option=com_ose_appcenter&view=adminlogin');
		}	
	}
	
	function initControl()
	{
		$this->controller = JRequest::getWord('controller', null);
		$this->_c = $this->getController();
	}

	function display($catchable=null, $params=null)
	{
		if (!JRequest::getWord('view', null)) {
			JRequest::setVar('view', 'dashboard');
		}
		parent::display();
	}

	function executeTask($task)
	{
		$this->_c->execute($task);
	}

	function getController()
	{
		$controller = $this->controller;
		if ($controller) {
			require_once(OSEAPPCENTER_B_CONTROLLER . DS . $controller . '.php');
			$class = get_class($this) . $controller;
			return new $class();
		}
		else {
			return $this;
		}
	}

	function redirectE()
	{
		$this->_c->redirect();
	}

	function getMod()
	{
		$result = array();
		$name = JRequest::getCmd('name', null);
		$type = JRequest::getCmd('type', null);
		$mod = JRequest::getCmd('mod', null);
		if (!empty($name) && !empty($type) && !empty($mod)) {
			echo '<script type="text/javascript">' . "\r\n";
			require_once(JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . $this->com_name . DS . 'modules' . DS . $mod . DS . $type . DS . 'ext.' . $type . '.' . $name
					. '.js');
			echo "\r\n" . '</script>';
		}
		exit;
	}
}
?>