<?php
/**
 * @version       1.0 +
 * @package       Open Source Excellence App Store Software
 * @author        Open Source Excellence (R) {@link  http://www.opensource-excellence.com}
 * @author        Created on 01-Oct-2011
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 *  @Copyright Copyright (C) 2008-2012 Open Source Excellence (R)
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
// no direct access
defined('_JEXEC') or die(';)');
jimport('joomla.application.component.modeladmin');

class OSEAPPCenterModelDashboard extends OSEAPPCenterModel
{
	protected $lists = array(), $pagination = null;
	private $_parent = null;
	private $_items = null;

	function __construct()
	{
		parent::__construct();
	}

	function getApps($appType = null)
	{
		$db = JFactory::getDBO();
		$where = array();
		$search = JRequest::getString('search', null);
		$start = JRequest::getInt('start', 0);
		$limit = 20;
		if (!empty($search)) {
			$searchEscaped = $db->Quote('%' . $db->getEscaped($search, true) . '%', false);
			$where[] = " a.title LIKE {$searchEscaped} ";
		}
		if (!empty($appType)) {
			$appType = $db->Quote($appType, true);
			$where[] = " a.cat = {$appType} ";
		}
		$where = OSESoftHelper::implodeWhere($where);
		$query = " SELECT count(id) FROM `#__ose_app_apps` AS a " . $where . " ORDER BY a.`id`";
		$db->setQuery($query);
		$total = $db->loadResult();
		$query = " SELECT a.* FROM `#__ose_app_apps` AS a " . $where . " ORDER BY a.`id`";
		$db->setQuery($query, $start, $limit);
		$results = $db->loadAssocList();
		$return = array();
		$i = 0;
		if (empty($results)) {
			$total = 0;
			$return = array();
		}
		else {
			foreach ($results as $result) {
				//$result['published']=($result['published'] == true) ? "Published" : "Unpublishded";
				$return[$i] = $result;
				$i++;
			}
		}
		unset($results);
		unset($result);
		unset($i);
		$result = array();
		$result['total'] = $total;
		$result['results'] = $return;
		return $result;
	}
	function saveConfiguration()
	{
		$db = JFactory::getDBO();
		$data['username'] = JRequest::getVar('username',null);
		$data['password'] = JRequest::getVar('password',null);
		$data['secretword'] = JRequest::getVar('secretword',null);
		
		$query = "SELECT COUNT(*) FROM `#__ose_app_conf`";
		$db->setQuery($query);
		$result = $db->loadResult();
		
		if ($result>0)
		{
			foreach ($data as $key => $value)
			{
				$query = "UPDATE `#__ose_app_conf` SET  `value` = ".$db->Quote(base64_encode($value))." WHERE  `key` = ".$db->Quote($key).";";
				$db->setQuery($query);
				$return = $db->query(); 
			}	
		}
		else
		{
			$query = " INSERT INTO `#__ose_app_conf` (`id`, `key`, `value`) VALUES ";
			$query_ext= array();
			foreach ($data as $key => $value)
			{
				$query_ext[] = " (NULL, '".$key."', ".$db->Quote(base64_encode($value)).")";
			}
			$query .= implode(',',$query_ext).";";
			$db->setQuery($query);
			$return = $db->query();
		}
		return $return;		
	}
	function getConfiguration()
	{
		$db = JFactory::getDBO();
		$query = " SELECT * FROM `#__ose_app_conf` ";
		$db->setQuery($query);
		$results = $db -> loadObjectlist(); 
		foreach ($results as $result)
		{
			$return[$result->key] = base64_decode($result ->value);
		} 
		$return['id'] = 0;
		$result = array();
		$result['total'] = COUNT($return);
		$result['results'] = $return;
		return $result;
	}
	function adminlogin()
	{
		$db = JFactory::getDBO();
		$secretword = JRequest::getVar('secretword');
		$query = " SELECT `value` FROM `#__ose_app_conf` WHERE `key` = 'secretword'";
		$db->setQuery($query);
		$result = $db -> loadResult();
		if (base64_decode($result)==$secretword)
		{
			$session = JFactory::getSession(); 
			$session ->set('oseisadmin', true); 
			return true; 	
		}
		else
		{
			return false;
		}	
	}
}
?>