<?php
/**
 * @version       1.0 +
 * @package       Open Source Excellence App Store Software
 * @author        Open Source Excellence (R) {@link  http://www.opensource-excellence.com}
 * @author        Created on 01-Oct-2011
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 *  @Copyright Copyright (C) 2008-2012 Open Source Excellence (R)
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
// no direct access
defined('_JEXEC') or die(';)');

class OSEAPPCenterModelInstaller extends OSEAPPCenterModel
{
	protected $lists = array(), $pagination = null;
	private $_parent = null;
	private $_items = null;
	protected $username = null;
	protected $password = null;
	protected $remoteid = null;
	protected $remoteHost = 'www.opensource-excellence.com';

	function __construct()
	{
		$this->getLoginInfo();
		
		parent::__construct();
	}
	function getLoginInfo()
	{
		$db = JFactory::getDBO();
		$query = "SELECT * FROM `#__ose_app_conf` ";
		$db->setQuery($query);
		$results = $db->loadObjectlist();
		foreach ($results as $result)
		{
			if ($result->key=='username')
			{
				$this->username = base64_decode($result->value);
			}
			elseif ($result->key=='password')
			{
				$this->password = base64_decode($result->value);
			}
		}
	}
	function returnMessages($status, $messages, $nextstep=null)
	{
		$result = array();
		if ($status == 1) {
			$result['success'] = true;
			$result['status'] = 'DONE';
			$result['result'] = $messages;
		}
		elseif($status == 2) {
			$result['success'] = true;
			$result['status'] = 'CONT';
			$result['result'] = $messages.'<br/><img src="components/com_ose_appcenter/assets/images/ajax-loader.gif" />';
			$result['nextstep'] = $nextstep;
		} 
		else {
			$result['success'] = false;
			$result['status'] = 'ERRO';
			$result['result'] = $messages;
		}
		$result = OSESoftHelper::encode($result);
		echo $result; exit;
	}
	
	function upgrade($appid, $step)
	{
		switch ($step)
		{
			case 1: 
				//$this->returnMessages(2, JText::_('LOGIN_SUCCESS'), 2);
				$this->remotelogin();
			break;
			case 2:
				//$this->returnMessages(2, JText::_('PACKAGE_DOWNLOAD'), 3);
				$this->downloadPackage();
			break;
			case 3:
				//$this->returnMessages(2, JText::_('PACKAGE_EXTRACTED_SUCCESS'), 4);
				$this->extractPackage();
			break;
			case 4: 
				//$this->returnMessages(2, JText::_('PACKAGE_INSTALLED_SUCCESS'), 5);
				$this->installPackage();
			break;
			case 6:
				echo 'test'; exit;
				//$this->returnMessages(1, JText::_('INSTALL_COMPLETED'));
				$this->updateVersion();
			break;	
		}
	}
	// Completed;	
	private function remotelogin()
	{
		$url = $this->remoteHost;
		$tmp = array();
		$req = "/index.php?option=com_ose_download&view=version&task=checkUser&username=" . $this->username . '&password=' . $this->password;
		$fp = fsockopen($url, 80, $errno, $errstr, 30);
		if (!$fp || $errno)
			return $errstr;
		@fputs($fp, "GET " . $req . " HTTP/1.1\r\n");
		@fputs($fp, "HOST: " . $url . "\r\n");
		@fputs($fp, "Connection: close\r\n\r\n");
		// read the body data
		$res = '';
		$headerdone = false;
		while (!feof($fp)) {
			$line = fgets($fp, 1024);
			if (strcmp($line, "\r\n") == 0) {
				// read the header
				$headerdone = true;
			}
			else if ($headerdone) {
				// header has been read. now read the contents
				$res .= $line;
			}
		}
		fclose($fp);
		preg_match('/{\"success.*}/', $res, $matches);
		if (!empty($matches[0])) {
			$this->returnMessages(2, JText::_('LOGIN_SUCCESS'), 2);
		}
		else {
			$this->returnMessages(0, JText::_('LOGIN_FAILED'));
		}
	}
//Completed;	
	private function getInfo($item, $id)
	{
		$db = JFactory::getDBO();
		$query = "SELECT `{$item}` FROM `#__ose_app_apps` WHERE `id` = " . (int) $id;
		$db->setQuery($query);
		$result = $db->loadResult();
		return $result;
	}
	// Completed
	private function downloadPackage()
	{
		$session = JFactory::getSession();
		$appid = JRequest::getInt('appid', null);
		if (empty($appid)) {
			$this->returnMessages(0, JText::_('APPID_VALUE_INVALID'));
		}
		$cur_version = $this->getInfo('cur_version', $appid);
		$new_version = $this->getInfo('new_version', $appid);
		if ($cur_version == $new_version) {
			$this->returnMessages(0, JText::_('VERSION_IS_LATEST_NO_UPDATE_NEEDED'));
		}
		$remote_id = $this->getInfo('remote_id', $appid);
		if (empty($remote_id)) {
			$this->returnMessages(0, JText::_('REMOTEID_VALUE_INVALID'));
		}
		$tmp = array();
		$url = "http://" . $this->remoteHost . "/index.php?option=com_ose_download&view=version&task=upgradeApp&username=" . $this->username . "&password=" . $this->password . "&fileid=". $remote_id;
		jimport('joomla.installer.installer');
		jimport('joomla.installer.helper');
		ini_set('allow_url_fopen', 'on');
		$p_file = JInstallerHelper::downloadPackage($url,'OSESECSUITE_UPGRADEPATCH.zip');
		ini_set('allow_url_fopen', 'off');
		// Was the package downloaded?
		if (!$p_file) {
			$this->returnMessages(3, JText::sprintf('PACKAGE_DOWNLOAD_FAILED', $url));
		}
		else
		{
			$session ->set('downloadedfile', $p_file);
			$this->returnMessages(2, JText::sprintf('PACKAGE_DOWNLOAD', $url), 3);
		}	
	}
// Completed	
	private function extractPackage()
	{
		$appid = JRequest::getInt('appid', null);
		if (empty($appid)) {
			$this->returnMessages(0, JText::_('APPID_VALUE_INVALID'));
		}
		$session = JFactory::getSession();
		$p_file = $session ->get('downloadedfile');
				
		$config = JFactory::getConfig();
		$tmp_dest = $config->get('tmp_path');
		$this->updateApps($appid, 'downloadedpath', '');

		// Unpack the downloaded package file
		$package = JInstallerHelper::unpack($tmp_dest . DS . $p_file);
		// Install the package
		if (empty($package['dir'])) {
			$this->returnMessages(0, JText::_('PACKAGE_EXTRACTED_FAILED'));
		}
		else {
			$this->updateApps($appid, 'downloadedpath', $package['extractdir']);
			$this->updateApps($appid, 'downloadeddate', date("Y-m-d h:i:s"));
			
			// Cleanup the install files
			if (!is_file($package['packagefile'])) {
				$package['packagefile'] = $config->get('tmp_path') . '/' . $package['packagefile'];
			}
			if (is_file($package['packagefile'])) {
				JFile::delete($package['packagefile']);
			}
			$this->returnMessages(2, JText::_('PACKAGE_EXTRACTED_SUCCESS'), 4);
		}
	}
//Completed	
	private function installPackage()
	{
		$appid = JRequest::getInt('appid', null);
		$appPath = $this->getInfo('downloadedpath', $appid);
		$appType = $this->getInfo('type', $appid);
		
		$tmp = array();
		if (!empty($appPath)) {

			if ($appType=='package')
			{
				$folders = JFolder:: folders($appPath); 
				foreach ($folders as $folder)
				{
					$source = $appPath.DS.$folder;
					$dest = JPATH_SITE.DS.$folder;
					$result = JFolder::copy($source, $dest, '', true); 
				}
				if ($result == true)
				{
					$this->updateApps($appid, 'cur_version', OSESUITEVERSION);
					$this->returnMessages(1, JText::_('PACKAGE_INSTALLED_COMPLETED'));
					
					//$this->returnMessages(2, JText::_('PACKAGE_INSTALLED_SUCCESS'), 6);
				}	
				else
				{
					$this->returnMessages(0, JText::_('PACKAGE_INSTALLED_FAILED'));
				}	
			}	
			else
			{
				jimport('joomla.installer.installer');
				jimport('joomla.installer.helper');
				$installer = JInstaller::getInstance();
				// Install the package
				if (!$installer->install($appPath)) {
					$this->returnMessages(0, JText::_('PACKAGE_INSTALLED_FAILED'));
				}
				// Does the unpacked extension directory exist?
				if (is_dir($appPath)) {
					$deleteResult = JFolder::delete($appPath);
					if ($deleteResult == true) {
						$this->updateApps($appid, 'downloadedpath', null);
						$this->updateApps($appid, 'downloadeddate', null);
					}
				}
				$option = $this->getInfo('option', $appid);
				$cur_version = $this->getVersion($option);
				$this->updateApps($appid, 'cur_version', $cur_version);
				$this->returnMessages(1, JText::_('PACKAGE_INSTALLED_SUCCESS'));
			}	
		}
		else {
			$this->returnMessages(0, JText::_('PACKAGE_INSTALLED_FAILED'));
		}
		
	}
	function updateVersion()
	{
		$xml = JFactory::getXML(JPATH_ADMINISTRATOR.DS.'manifests'.DS.'packages'.DS.'pkg_osesecsuite.xml');
		print_r($xml);  exit;
		$this->updateApps($appid, 'cur_version', OSESUITEVERSION);
		$this->returnMessages(1, JText::_('PACKAGE_INSTALLED_COMPLETED'));
	}
	
	function updateApps($id, $field, $value)
	{
		$db = JFactory::getDBO();
		$query = "UPDATE `#__ose_app_apps` SET `" . $field . "` = " . $db->Quote($value, true) . " WHERE `id` = " . (int) $id;
		$db->setQuery($query);
		if ($db->query()) {
			return true;
		}
		else {
			return false;
		}
	}

	function getLastestVersion($remote_id)
	{
		$host = $this->remoteHost;
		$postVar['option'] = 'com_ose_download';
		$postVar['view'] = 'version';
		$postVar['task'] = 'checkversion';
		$postVar['fileid'] = 1;
		$content = '';
		$path = '/';
		foreach ($postVar AS $key => $val) {
			$content .= "&" . urlencode($key) . "=" . urlencode($val);
		}
		$response = self::fsockconnect($host, $content);
		preg_match("/{version:.*}/", $response, $matches);
		if (isset($matches[0])) {
			$version = preg_replace(array("/{version:/","/}/"), "", $matches[0]);
		}
		else {
			$version = null;
		}
		return $version;
	}

	function fsockconnect($host, $content)
	{
		$posturl = "" . $host;
		$header = "Host: $host\r\n";
		$header .= "User-Agent: PHP Script\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($content) . "\r\n";
		$header .= "Connection: close\r\n\r\n";
		$fp = fsockopen($posturl, 80, $errno, $errstr, 30);
		if (!$fp) {
			$response = false;
		}
		else {
			error_reporting(E_ERROR);
			fputs($fp, "POST $path  HTTP/1.1\r\n");
			fputs($fp, $header . $content);
			//fwrite($fp, $header."\r\n".$content);
			$response = "";
			while (!feof($fp)) {
				$response = $response . fgets($fp, 128);
			}
			fclose($fp);
			error_reporting(E_ALL ^ E_NOTICE);
		}
		return $response;
	}

	function getVersion($option)
	{
		$folder = JPATH_ADMINISTRATOR . DS . 'components' . DS . $option;
		if (JFolder::exists($folder)) {
			$xmlFilesInDir = JFolder::files($folder, '.xml$');
		}
		else {
			$folder = JPATH_SITE . DS . 'components' . DS . $option;
			if (JFolder::exists($folder)) {
				$xmlFilesInDir = JFolder::files($folder, '.xml$');
			}
			else {
				$xmlFilesInDir = null;
			}
		}
		$xml_items = '';
		if (count($xmlFilesInDir)) {
			foreach ($xmlFilesInDir as $xmlfile) {
				if ($data = JApplicationHelper::parseXMLInstallFile($folder . DS . $xmlfile)) {
					foreach ($data as $key => $value) {
						$xml_items[$key] = $value;
					}
				}
			}
		}
		if (isset($xml_items['version']) && $xml_items['version'] != '') {
			return $xml_items['version'];
		}
		else {
			return '';
		}
	}
}
?>
