<?php
/**
 * @package		Joomla.Administrator
 * @subpackage	Templates.bluestork
 * @copyright	Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.filesystem.file');

$app = JFactory::getApplication();
$doc = JFactory::getDocument();

$doc->addStyleSheet('templates/system/css/system.css');
$doc->addStyleSheet('templates/'.$this->template.'/css/template.css');

if ($this->direction == 'rtl') {
	$doc->addStyleSheet('templates/'.$this->template.'/css/template_rtl.css');
}

/** Load specific language related css */
$lang = JFactory::getLanguage();
$file = 'language/'.$lang->getTag().'/'.$lang->getTag().'.css';
if (JFile::exists($file)) {
	$doc->addStyleSheet($file);
}
require_once(dirname(__FILE__).'/osePanel.php');
$osePanel = new osePanel();
$oseVersion = $osePanel->getVersion();
JHtml::_('behavior.noframes');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>" >
<head>
<jdoc:include type="head" />

<!--[if IE 7]>
<link href="templates/<?php echo  $this->template ?>/css/ie7.css" rel="stylesheet" type="text/css" />
<![endif]-->

<script type="text/javascript">
	window.addEvent('domready', function () {
		document.getElementById('form-login').username.select();
		document.getElementById('form-login').username.focus();
	});
</script>
</head>
<body>
<div id="ose-social" name="ose-social">
					<section class="ose-page">
						<div class="social">
							<a target="__blank" href="https://www.opensource-excellence.com/customers/member-support-request.html">Support Center</a>
						</div>
						<div class="social">
							<a target="__blank" href="http://www.facebook.com/osexcellence">Like us</a>
						</div>
						<div class="social">
							<a target="__blank" href="http://extensions.joomla.org/extensions/tools/security-tools/7032">Vote us in JED</a>
						</div>
						<div class="social">
							<?php echo $oseVersion; ?> 
						</div>
					</section>
	</div>
	<div id="border-top" class="h_blue">
		<div class="oselogo"></div>
		<span class="ose-version"><?php echo 'OSE Security Suite 2014 '. JText::_("Version").': '.OSESUITEVERSION ?></span>
	</div>
	<div id="content-box">
			<div id="element-box" class="login">
				<div class="m wbg">
					<h1><?php echo JText::_('COM_LOGIN_JOOMLA_ADMINISTRATION_LOGIN') ?></h1>
					<jdoc:include type="message" />
					<jdoc:include type="component" />
					<p><?php echo JText::_('COM_LOGIN_VALID') ?></p>
					<p><a href="<?php echo JURI::root(); ?>"><?php echo JText::_('COM_LOGIN_RETURN_TO_SITE_HOME_PAGE') ?></a></p>
					<div id="lock"></div>
				</div>
			</div>
			<noscript>
				<?php echo JText::_('JGLOBAL_WARNJAVASCRIPT') ?>
			</noscript>
	</div>
	<div id="footer">
	<p class="oselogo">
		<a href="http://www.opensource-excellence.com" target="_blank">
			<img src ="templates/bluestork/images/logo.png" height="50px" weight="50px" />
		</a>	
	</p>
		
	<p class="copyright">
		&copy; 2008 - <?php echo date("Y"); ?> <a href="http://www.opensource-excellence.com" target="_blank">Open Source Excellence&#0174;</a>. All Rights Reserved. <br /> Credits to: <a href="http://www.joomla.org" target="_blank">Joomla!&#0174;</a> A Free Software released under the GNU/GPL License.
	</p>

	</div>
</body>
</html>
