<?php 
class osePanel {
	public $timezone = 'America/Los_Angeles';
	public function __construct () {
		
	}
	public function getVersion() {
		$version = $this->getJEDVersion () ;
		return $version; 
	}
	private function getJEDVersion () {
		if (!function_exists('allow_url_fopen') && !function_exists('ini_set'))
		{
			return 'N/A';
		}
		else if (!function_exists('allow_url_fopen') && function_exists('ini_set'))
		{
			ini_set('allow_url_fopen', 'on');
		}
		if ($this->isVersionChecked () == false)
		{
			$tmp = $this->getJEDVersionFromWeb ();
			$v = $this->getVersionChecked (); 
			if (empty($v))
			{
				$this->insertVersionChecked ($tmp[0]);
			}
			return $tmp[0];
		}
		else 
		{
			$version = $this->getVersionChecked ();
			return $version; 
		}
	}
	private function getJEDVersionFromWeb () {
		//$url = "http://extensions.joomla.org/extensions/tools/security-tools/7032";
		//$jedContent = file_get_contents($url);
		//$matches = array();
		//$tmp = array(); 
		//preg_match("/\<div\s*class=\"caption\"\>Version\<\/div\>\<div\s*class\=\"data\"\>\d\.\d\.\d\s*.*?\<\/div\>/", $jedContent, $matches);
		//preg_match("/\d\.\d\.\d/", $matches[0], $tmp);
		return  OSESUITEVERSION; 
	}
	private function getTimeZone () {
		if (function_exists('ini_get'))
		{
			$timezone = ini_get('date.timezone');
			if (empty($timezone))
			{
				$this->setTimeZone ();  
			}
			else
			{
				$timezone = date_default_timezone_get();
				$this->setTimeZone ($timezone); 
			}
		}
	}
	private function setTimeZone ($timezone=null) {
		if (function_exists('ini_set') && empty($timezone))
		{
			ini_set('date.timezone', $this->timezone);
		}	
		else
		{
			$this->timezone = $timezone;
		}
	}
	private function isVersionChecked () {
		$db = JFactory::getDBO(); 
		$query = "SELECT `value` FROM `#__ose_secConfig` WHERE `key` = 'version_checkedsut' ";
		$db->setQuery($query); 
		$date = $db->loadResult();
		if (empty($date)) {
			return false;
		}
		else
		{
			$this->getTimeZone ();
			$tz_object = new DateTimeZone($this->timezone);
			$datetime1 = new DateTime($date, $tz_object);
			$datetime2 = new DateTime("now", $tz_object);
			$interval = round(($datetime2->format('U') - $datetime1->format('U')) / (60*60*24)); 
			if ($interval >=1)
			{
				return false;
			}
			else 
			{
				return true; 
			}
		}
	}
	private function getVersionChecked () {
		$db = JFactory::getDBO(); 
		$query = "SELECT `value` FROM `#__ose_secConfig` WHERE `key` = 'version_osesut' ";
		$db->setQuery($query); 
		return $db->loadResult(); 
	}
	private function insertVersionChecked ($version) {
		$db = JFactory::getDBO(); 
		$query = "INSERT INTO `#__ose_secConfig` 
				  (`id`, `key`, `value`, `type`, `default`) VALUES
				  (NULL, 'version_checkedsut', '".date("Y-m-d")."', 'global', '');";
		$db->setQuery($query); 
		$db->query();

		$query = "INSERT INTO `#__ose_secConfig` 
				  (`id`, `key`, `value`, `type`, `default`) VALUES
				  (NULL, 'version_osesut', ". $db->Quote($version).", 'global', '');";
		$db->setQuery($query); 
		$db->query();
	}
	
}

?>